unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    StaticText1: TStaticText;
    Edit5: TEdit;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ProgressBar1: TProgressBar;
    MainMenu1: TMainMenu;
    Help2: TMenuItem;
    About2: TMenuItem;
    HowtoUseHelp2: TMenuItem;
    SearchforHelpOn2: TMenuItem;
    Contents2: TMenuItem;
    GroupBox3: TGroupBox;
    Edit7: TEdit;
    GroupBox4: TGroupBox;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    GroupBox5: TGroupBox;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    StaticText17: TStaticText;
    StaticText18: TStaticText;
    StaticText19: TStaticText;
    StaticText20: TStaticText;
    StaticText21: TStaticText;
    StaticText22: TStaticText;
    StaticText24: TStaticText;
    Label2: TLabel;
    Button2: TButton;
    Shape11: TShape;
    StaticText2: TStaticText;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure About2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Plotado: Boolean;

implementation

Uses Unit2;

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
var
 r, x, y, v1, v2: integer;
 c, Vp : double;
begin
button1.Enabled := false;
button2.Enabled := false;
application.ProcessMessages;
if (edit1.text <> '') and (edit2.text <> '') and (edit7.text <> '') and (edit5.text <> '')then
 begin
  Vp:=0;
  progressbar1.Max := (paintbox1.Height + 1) * (paintbox1.Width + 1);
  r := strtoint(edit5.text);
  c := strtofloat(edit7.text);
  v1 := strtoint(edit1.text);
  v2 := strtoint(edit2.text);

  c := c/10;

  for x := -75 to 75 do
   begin
    for y := -75 to 75 do
     begin
      progressbar1.stepit;
      if (sqr(x)+sqr(y)<sqr(r)) then
       begin
        Vp := (((v1+v2)/2) + ((v1-v2)/pi) * (arctan ( (2*r*y) / ( sqr(r) - (sqr(x)+sqr(y))) ) ));

        if (Vp < 0 ) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clwhite
        else if (Vp > 0) and (Vp < c) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clGreen
        else if (Vp >= c) and (Vp < c*2) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clred
        else if (Vp >= c*2) and (Vp < c*3) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clblue
        else if (Vp >= c*3) and (Vp < c*4) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clAqua
        else if (Vp >= c*4) and (Vp < c*5) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clblack
        else if (Vp >= c*5) and (Vp < c*6) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clGray
        else if (Vp >= c*6) and (Vp < c*7) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clOlive
        else if (Vp >= c*7) and (Vp < c*8) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clMaroon
        else if (Vp >= c*8) and (Vp < c*9) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clFuchsia
        else if (Vp >= c*9) and (Vp < c*10) then
         paintbox1.Canvas.Pixels[x+75, y+75] := clTeal
        else
         paintbox1.Canvas.Pixels[x+75, y+75] := clwhite;
        Vp := 0;
       end;// ver se est na area circular
     end;    // end do for 1
   end;      // end do for 2
  plotado := true;
  button1.Enabled := true;
  button2.Enabled := true;
 end
else
 showmessage('Valores imcompletos');  // primeiro if de valores vazios
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if not (key in ['0','1','2','3','4','5','6','7','8','9', #32]) then
 Key := #0;
end;

procedure TForm1.About2Click(Sender: TObject);
begin
  Aboutbox.showmodal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
paintbox1.Refresh;
plotado := false;
progressbar1.Position := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
plotado := False;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
button2.Click;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
 r, v1, v2: integer;
 c, Vp : double;
begin
if plotado then
 if (edit1.text <> '') and (edit2.text <> '') and (edit7.text <> '') and (edit5.text <> '')then
   begin
    Vp:=0;
    progressbar1.Max := (paintbox1.Height + 1) * (paintbox1.Width + 1);
    r := strtoint(edit5.text);
    c := strtofloat(edit7.text);
    v1 := strtoint(edit1.text);
    v2 := strtoint(edit2.text);

    x := x - 75;
    y := y - 75;

    if (sqr(x)+sqr(y)<sqr(r)) then
     begin
      Vp := (((v1+v2)/2) + ((v1-v2)/pi) * (arctan((2*r*y)/(sqr(r)-(sqr(x)+sqr(y))))));
      label2.caption := 'x = ' + inttostr(x) + '  y = ' + inttostr(y) + '  Vp = ' + floattostr(Vp);
     end
    else
     label2.caption := '';
   end
  else
   label2.Caption := '';
  end;

end.

